package prupp;

// $Id: CacheSender.java,v 1.7 1999/01/17 22:01:42 d94-rol Exp $

import java.net.*;
import java.io.*;

/** A basic Sender, reads a file from the cache and sends it to the 
 *  requesting client. 
 */
public class CacheSender extends Responder
{
    /** Create a CacheSender with a client and a CacheEntry
     * @param reqLine the request being handled.
     * @param input The inputstream from the client.
     * @param output The outputstream to the client.
     * @param entry the NCacheEntry with the file to send
     */
    public CacheSender (String reqLine, DataInputStream input, DataOutputStream output, NCacheEntry entry) {
	super (reqLine, input, output);
	setExtraInfo ("used cache");
	Proxy.getLogger ().inc ("CacheSender(s) created");
	if (input == null || output == null || entry == null) {
	    Proxy.logError ("CacheSender called with null argument(s)");
	    return;
	}
	try {
	    InputStream file = new FileInputStream(entry.getFileName ());
      
	    byte v[] = new byte[102400]; // 100kB blocks should be good.
	    int read;
	    while ((read = file.read(v)) > 0)
		clientos.write (v,0,read);
	    file.close ();
	} catch (FileNotFoundException e){
	    Proxy.logError ("Couldnt find the file " + entry.getFileName ());
	    error ("Seems to me that the cache is broken: " + e);
	    return;
	} catch (IOException e) {
	    Proxy.logError ("Error writing from cache:" + e);
	    return;
	}
    }
}
