package prupp;

// $Id: CacheStatus.java,v 1.6 1999/01/17 22:01:42 d94-rol Exp $

import java.io.*;
import java.net.*;
import java.util.*;

/** print out the status of the cache.
 */
public class CacheStatus implements MetaHandler {
    /** default constructor */
    public CacheStatus () {
    }

    /** handler of a MetaPage.
     * @param input the InputStream from the client.
     * @param output the OutputStream to the client.
     * @param url the requested url.
     * @param htab the supplied argument to the page (CGI-parameters).
     * @param uap the username and paswword as by Basic-authentication
     */
    public void handle (DataInputStream input, DataOutputStream output, URL url, Properties htab, String uap) {
	try {      
	    StringBuffer res = new StringBuffer (Proxy.getHeader ().toString() + 
						 HTMLPage.getPageHeader ("CacheStatus") + 
						 "Cachedir   : " + Proxy.getCache ().getCacheDir () + "<br>\n" +
						 "current Size: " + Proxy.getCache ().getCurrentSize () + "<br>\n" +
						 "Max Size: " + Proxy.getCache ().getMaxSize () + "<br>\n" +
						 "Cachetime : " + (Proxy.getCache ().getCacheTime () / 1000) + "s.<br>\n" +
						 HTMLPage.getTableHeader (100, 1) +
						 HTMLPage.getTableTopicRow () + 					     
						 "<th>URL</th><th>filename</th><th>size</th><th>expires</th></tr>\n");
	    

	    Enumeration e = Proxy.getCache ().getEntries ();
	    long totalsize = 0;
	    while (e.hasMoreElements ()) {	       
		NCacheEntry lister = (NCacheEntry) e.nextElement ();
		String filev = lister.getKey ().toString ();
		if (filev.length () > 60)
		    filev = filev.substring (0,57) + "...";
		res.append ("<tr><td><a href = \"" + lister.getKey () + "\" target = cacheview>" + filev + "</a></td>" + 
			    "<td>" + lister.getFileName () + "</td>" +
			    "<td>" + lister.getSize () + "</td>" +
			    "<td>" + lister.getExpires () + "</td></tr>\n");
		totalsize += lister.getSize ();
	    }
	    res.append ("<tr><td><B>Total:</b></td><td>&nbsp;</td><td>" + totalsize + "</td><td>&nbsp;</td></tr>\n");
	    res.append ("</table>\n</body></html>");	       
	    
	    output.write (res.toString ().getBytes ());
	} catch (IOException e) {
	    Proxy.logError ("Couldnt write status");
	}
    }
}
