package prupp.filter;

// $Id: BackgroundFilter.java,v 1.7 1998/12/22 20:26:36 d94-rol Exp $

import java.util.*;
import prupp.html.*;

/** Remove background images from pages.
 */
public class BackgroundFilter extends Filter
{
    private boolean done = false;
  
    /** constructor */
    public BackgroundFilter () {
    }

    /** Filter away backgroundimges(found in the body-tag) on webpages.
     * @param block the HTMLBlock were about to filter.
     * @return the uncertain area of the block.
     */
    public String filter(HTMLBlock block) {
	Vector tags = block.getElements ();
	for (int i = 0; i < tags.size (); i++) {
	    Object o = tags.elementAt (i);
	    if (!isString (o)) {
		HTMLTag tag = (HTMLTag)o;
		if (tag.getType ().equals ("BODY") || 
		    tag.getType ().equals ("TABLE") ||
		    tag.getType ().equals ("TR") ||
		    tag.getType ().equals ("TD")) {
		    tag.removeAttribute ("BACKGROUND");
		} 
	    }
	}
	return null;
    }
  
    /** Called when you want to setup how this filter should work.
     * @param properties the properties to use.
     */
    public static void setup (Properties properties) {
	// supress warning in logs.
    }

    /** Called when you want to get the possible settings this filter 
     *  support. 
     */
    public static Properties getProperties () {
	return new Properties ();
    }
}

